package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo.p2j_test.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in test_denormalization.p).
 */
public class TestDenormalization
{
   Person.Buf person = RecordBuffer.define(Person.Buf.class, "p2j_test", "person", "person");

   /**
    * External procedure (converted to Java from the 4GL source code
    * in test_denormalization.p).
    */
   public void execute()
   {
      externalProcedure(new Block()
      {
         integer i = new integer(0);

         public void init()
         {
            TransactionManager.registerUndo(i);
         }

         public void body()
         {
            RecordBuffer.openScope(person);
            person.deleteAll();
            
            ToClause toClause0 = new ToClause(i, 1, 4);
            
            repeatTo(TransactionType.FULL, "loopLabel0", toClause0, new Block()
            {
               public void body()
               {
                  person.create();
                  person.setSchedule2(person.getScheduleFifth());
                  person.setSsn(concat("aassn_", chr(plus(i, 83))));
                  person.setLastName(new character(""));
                  person.setMiddleInit(new character(""));
                  person.setFirstName(new character("A.B"));
                  person.setEmpNum(plus(plus(modulo(i, 3), multiply(172, i)), 222));
                  person.setExtension(concat("sext+", chr(plus(i, 83))));
                  person.setSiteId(plus(plus(modulo(i, 3), multiply(172, i)), 222));
               }
            });
            
            person.deleteAll();
            message("delete all for permanent 1");
            message("delete all for permanent 2");
            
            ToClause toClause1 = new ToClause(i, 1, 4);
            
            repeatTo(TransactionType.FULL, "loopLabel1", toClause1, new Block()
            {
               public void body()
               {
                  person.create();
                  person.setSchedule(minus((i), 1), person.getSchedule(minus((plus(i, 1)), 1)));
                  person.setSsn(concat("aassn_", chr(plus(i, 83))));
                  person.setLastName(new character(""));
                  person.setMiddleInit(new character(""));
                  person.setFirstName(new character("A.B"));
                  person.setEmpNum(plus(plus(modulo(i, 3), multiply(172, i)), 222));
                  person.setExtension(concat("sext+", chr(plus(i, 83))));
                  person.setSiteId(plus(plus(modulo(i, 3), multiply(172, i)), 222));
               }
            });
            
            person.deleteAll();
            message("delete all for permanent 3");
            message("delete all for permanent 4");
            
            ToClause toClause2 = new ToClause(i, 1, 4);
            
            repeatTo(TransactionType.FULL, "loopLabel2", toClause2, new Block()
            {
               public void body()
               {
                  person.create();
                  person.setSchedule(minus((plus(i, 1)), 1), person.getSchedule1());
                  person.setSsn(concat("aassn_", chr(plus(i, 83))));
                  person.setLastName(new character(""));
                  person.setMiddleInit(new character(""));
                  person.setFirstName(new character("A.B"));
                  person.setEmpNum(plus(plus(modulo(i, 3), multiply(172, i)), 222));
                  person.setExtension(concat("sext+", chr(plus(i, 83))));
                  person.setSiteId(plus(plus(modulo(i, 3), multiply(172, i)), 222));
               }
            });
            
            message("delete all for permanent 5");
            message("delete all for permanent 6");
         }
      });
   }
}
